/*
 * BaseDialog.fx
 *
 * Created on 23.07.2009, 14:54:48
 */

package org.openoffice.setup.FX.dialog;

import org.openoffice.setup.FX.frame.*;

/**
 * @author is93718
 */

abstract public class Dialog {

    public var helpFileText: String;
    public var titleText: String;

    var helpFileName: String;
    var titleContent: TitleContent;
    var mainContent: MainContent;
    var buttonContent: ButtonContent;
    var cancelDialogText: String = "Do you really want to cancel the installation?";
    var cancelDialogTitle: String = "Cancel installation?";
    var confirmText: String = "Ok";

    abstract public function getNext(): String;
    abstract public function getPrevious(): String;
    abstract public function getName(): String;
    abstract public function getHelpFileName(): String;
    abstract public function getHelpText(): String;
    abstract public function getTitleContent(): TitleContent;
    abstract public function getMainContent(): MainContent;
    abstract public function getButtonContent(): ButtonContent;

    public function beforeShow(): Void {
    }

    public function duringShow(): Void {
    }

    public function afterShow(isNext: Boolean): Boolean {
        var repeatDialog: Boolean = false;
        return repeatDialog
    }

    public function doStart(): Void {
    }

    public function getCancelText(): String {
        return cancelDialogText;
    }

    public function getCancelTitle(): String {
        return cancelDialogTitle;
    }

    public function getConfirmText(): String {
        return confirmText;
    }

    public function getButtonEvent(button: String): String {
        var event : String;
        if ( button.equals("buttonBack")) { event = "back" }
        else if ( button.equals("buttonNext")) { event = "next" }
        else if ( button.equals("buttonCancel")) { event = "cancel" }
        else if ( button.equals("buttonHelp")) { event = "help" }
        return event
    }

}
