/*
 * WelcomeDialog.fx
 *
 * Created on 23.07.2009, 14:30:27
 */

package org.openoffice.setup.FX.dialog;

import org.openoffice.setup.FX.controller.JavaFXTaskBase;
import org.openoffice.setup.FX.dialog.Dialog;
import org.openoffice.setup.FX.frame.*;
import org.openoffice.setup.Installer.Installer;
import org.openoffice.setup.Installer.InstallerFactory;
import org.openoffice.setup.SetupData.PackageDescription;
import org.openoffice.setup.SetupData.SetupDataProvider;

import java.lang.String;
import javafx.scene.paint.Color;

import org.openoffice.setup.FX.Main;

import org.openoffice.setup.Util.LogManager;
import org.openoffice.setup.Util.SystemManager;

import java.util.Vector;

import java.io.File;

/**
 * @author is93718
 */

public class InstallationDoneDialog extends Dialog {

    override public var helpFileText = "Dieses ist die Hilfe des InstallationDone-Dialoges";
    override public var titleText = "Installation beendet";

    var helpFileName: String = "String_Helpfile_InstallationCompleted";
    var mainLabelText: String = "Installation beendet";
    // var titleText: String = ResourceManager.getString("String_Prologue1");
    var dialogName: String = "InstallationDone";  // only for Info

    var titleContent: TitleContent = TitleContent {
                                         titleTextString: titleText;
                                         titleLogoColor: Color.GREEN;
                                     }

    var mainContent: MainContentWelcome = MainContentWelcome {
                                              labelText: mainLabelText;
                                          }

    var buttonContent: ButtonContent = ButtonContent {
                                           visibleButtonBack: false
                                           visibleButtonNext: false
                                           visibleButtonCancel: false
                                           visibleButtonHelp: false
                                           textButtonNext: "Finish"
                                       };

    public override function getNext(): String {
        return "";
    }

    public override function getPrevious(): String {
        return "";
    }

    public override function beforeShow(): Void {
    }

    public override function duringShow(): Void {
    }

    public override function afterShow(isNext: Boolean): Boolean {
        var repeatDialog: Boolean = false;
        return repeatDialog
    }

    public override function doStart(): Void {

        JavaFXTaskBase {
            action: function() {

                // JavaFX Todo
                if ( not Main.installData.getOSType().startsWith("Windows")) {
                    var packageData: PackageDescription = SetupDataProvider.getPackageDescription();
                    var installer: Installer = InstallerFactory.getInstance();
                    installer.postInstall(packageData);
                }

                saveLogFile(LogManager.getModulesLogFile(), "modules_");
                saveLogFile(LogManager.getLogfile(), "log_");
                saveLogFile(LogManager.getCommandsLogfile(), "commands_");

                if ( Main.installData.isDownloadInstallation() ) {
                    if ( new File(Main.installData.getDownloadTempPath()).exists() ) {
                        SystemManager.removeDirectory(new File(Main.installData.getDownloadTempPath()));
                    }
                }

                buttonContent.publicVisibleButtonNext = true;

                FX.deferAction(function() { buttonContent.updateContent() }); // update dialog
            }
        }.start();

    }
    
    public override function getName(): String {
        return dialogName;
    }

    public override function getHelpFileName(): String {
        return helpFileName;
    }

    public override function getHelpText(): String {
        return helpFileText;
    }

    public override function getTitleContent(): TitleContent {
        return titleContent
    }

    public override function getMainContent(): MainContent {
        return mainContent
    }

    public override function getButtonContent(): ButtonContent {
        return buttonContent
    }

    public override function getButtonEvent(button: String): String {
        var event : String;
        if ( button.equals("buttonBack")) { event = "back" }
        else if ( button.equals("buttonNext")) { event = "exit" }
        else if ( button.equals("buttonCancel")) { event = "cancel" }
        else if ( button.equals("buttonHelp")) { event = "help" }
        return event
    }

    function saveLogFile(content: Vector, name: String): Void {
        var fullPath: String = Main.installData.getLogDirName();
        var fileName: String = "{name}{Main.installData.getProcessId()}.log";
        var file: File = new File(fullPath, fileName);

        println("Saving file: {file.getPath()}");

        SystemManager.createDirectory(new File(fullPath));
        SystemManager.saveCharFileVector(file.getPath(), content)
    }

}
