/*
 * LicenseDialog.fx
 *
 * Created on 23.07.2009, 15:01:07
 */

package org.openoffice.setup.FX.dialog;

import javafx.scene.paint.Color;
import org.openoffice.setup.FX.Main;
import org.openoffice.setup.FX.frame.*;



import java.awt.Dimension;
import javax.swing.border.EmptyBorder;

import java.awt.Insets;

/**
 * @author is93718
 */

public class LicenseDialog extends Dialog {

    override public var helpFileText = "Dieses ist die Hilfe des License-Dialoges";
    override public var titleText = "Lizenz";

    var helpFileName: String = "String_Helpfile_AcceptLicense";
    var dialogName: String = "License"; // only for Debugging
    var mainLabelText: String = "Bitte lesen Sie diese Lizenz sorgfältig durch.";
    var licenseText: String = "<b>This is the important license text.</b><p>Please read this text carefully!<p>Are you sure?<p>Please read again!<p>Now press the button.<p>And once more please.";

    var titleContent: TitleContent = TitleContent {
                                         titleTextString: titleText;
                                         titleLogoColor: Color.RED;
                                     };

    var mainContent: MainContentLicense = MainContentLicense {
                                       labelText: mainLabelText;
                                       licenseText: licenseText;
                                   }

    var buttonContent: ButtonContent = ButtonContent {
                                           textButtonNext: "Accept >"
                                       };

    public override function getNext(): String {
        if ( Main.installData.isRootInstallation() ) {
            if ( Main.installData.olderVersionExists() ) {
                return new String("ReadyToInstall");
            } else if ( Main.installData.sameVersionExists() ) {
                return new String("ModuleSelection");
            } else {
                return new String("PathSelection");
            }
        } else {
            return new String("PathSelection");
        }
    }

    public override function getPrevious(): String {
        return "Welcome";
    }

    public override function beforeShow(): Void {
        mainContent.scrollPane.setPreferredSize(new Dimension(350, 160));
        mainContent.textPane.setBackground(java.awt.Color.LIGHT_GRAY);
        mainContent.displayText.opacity = 0.8;
    }

    public override function duringShow(): Void {
    }

    public override function afterShow(isNext: Boolean): Boolean {
        var repeatDialog: Boolean = false;
        return repeatDialog
    }

    public override function getName(): String {
        return dialogName;
    }

    public override function getHelpFileName(): String {
        return helpFileName;
    }

    public override function getHelpText(): String {
        return helpFileText;
    }

    public override function getTitleContent(): TitleContent {
        return titleContent
    }

    public override function getMainContent(): MainContent {
        return mainContent
    }

    public override function getButtonContent(): ButtonContent {
        return buttonContent
    }

}
