/*
 * WelcomeDialog.fx
 *
 * Created on 23.07.2009, 14:30:27
 */

package org.openoffice.setup.FX.dialog;

import org.openoffice.setup.FX.Main;
import org.openoffice.setup.FX.dialog.Dialog;
import org.openoffice.setup.FX.frame.*;
import javafx.scene.paint.Color;

import java.lang.System;

import org.openoffice.setup.ResourceManager;
import org.openoffice.setup.SetupData.PackageDescription;
import org.openoffice.setup.SetupData.ProductDescription;
import org.openoffice.setup.SetupData.SetupDataProvider;
import org.openoffice.setup.Util.InfoCtrl;


import org.openoffice.setup.Util.ModuleCtrl;

/**
 * @author is93718
 */

public class ReadyToUninstallDialog extends Dialog {

    override public var helpFileText = "Dieses ist die Hilfe des ReadyToUninstall-Dialoges";
    override public var titleText = "Ready to uninstall";

    var helpFileName: String = "String_Helpfile_UninstallationImminent";
    var mainLabelText: String = "Die Deinstallation kann beginnen";
    var dialogName: String = "ReadyToUninstall";  // only for Info
    var htmlInfoText: String = "";

    var titleContent: TitleContent = TitleContent {
                                         titleTextString: titleText;
                                         titleLogoColor: Color.GREEN;
                                     }

    // Also using Welcome main content
    var mainContent: MainContentWelcome = MainContentWelcome {
                                              labelText: mainLabelText;
                                          }

    var buttonContent: ButtonContent = ButtonContent {
                                           textButtonNext: "Uninstall >"
                                       };

    public override function getNext(): String {
        return "UninstallationOngoing"
    }

    public override function getPrevious(): String {
        if ( Main.installData.isCustomInstallation() ) {
            return new String("UninstallModuleSelection");
        } else if ( Main.installData.isTypicalInstallation() ) {
            return new String("UninstallType");
        } else {
            System.err.println("Error: Unknown uninstallation type!" );
            return new String("Error");
        }
    }

    public override function beforeShow(): Void {
        
        var StringInstall: String = ResourceManager.getString("String_Uninstall");

        var productData: ProductDescription = SetupDataProvider.getProductDescription();
        var packageData: PackageDescription = SetupDataProvider.getPackageDescription();

        htmlInfoText = InfoCtrl.setHtmlFrame("header", htmlInfoText);
        htmlInfoText = InfoCtrl.setReadyToInstallInfoText(productData, htmlInfoText);
        htmlInfoText = InfoCtrl.setReadyToInstallInfoText(packageData, htmlInfoText);
        htmlInfoText = InfoCtrl.setHtmlFrame("end", htmlInfoText);

        // UninstallationImminent panel = (UninstallationImminent)getPanel();
        // panel.setInfoText(htmlInfoText);
        // panel.setCaretPosition();

        // System.err.println("\nUninstallation module state dump 3:");
        // Dumper.dumpModuleStates(packageData);
    }

    public override function duringShow(): Void {
    }

    public override function afterShow(isNext: Boolean): Boolean {
        var repeatDialog: Boolean = false;

        if ( isNext ) {
            var packageData: PackageDescription = SetupDataProvider.getPackageDescription();
            ModuleCtrl.setHiddenModuleSettingsUninstall(packageData);
            // Dumper.dumpUninstallPackages(packageData);

            // System.err.println("\nUninstallation module state dump 4:");
            // Dumper.dumpModuleStates(packageData);
        }

        return repeatDialog
    }

    public override function getName(): String {
        return dialogName;
    }

    public override function getHelpFileName(): String {
        return helpFileName;
    }

    public override function getHelpText(): String {
        return helpFileText;
    }

    public override function getTitleContent(): TitleContent {
        return titleContent
    }

    public override function getMainContent(): MainContent {
        return mainContent
    }

    public override function getButtonContent(): ButtonContent {
        return buttonContent
    }

}
