/*
 * WelcomeDialog.fx
 *
 * Created on 23.07.2009, 14:30:27
 */

package org.openoffice.setup.FX.dialog;

import org.openoffice.setup.FX.dialog.Dialog;
import org.openoffice.setup.FX.frame.*;
import javafx.scene.paint.Color;


import java.lang.String;
import org.openoffice.setup.FX.Main;
import org.openoffice.setup.ResourceManager;
import org.openoffice.setup.Util.InfoCtrl;

import org.openoffice.setup.SetupData.ProductDescription;
import org.openoffice.setup.SetupData.SetupDataProvider;

/**
 * @author is93718
 */

public class UninstallationDoneDialog extends Dialog {

    override public var helpFileText = "Dieses ist die Hilfe des UninstallationDone-Dialoges";
    override public var titleText = "Deinstallation beendet";

    var helpFileName: String = "String_Helpfile_UninstallationCompleted";
    var mainLabelText: String = "Deinstallation beendet";
    // var titleText: String = ResourceManager.getString("String_Prologue1");
    var dialogName: String = "UninstallationDone";  // only for Info

    var htmlInfoText: String;

    var titleContent: TitleContent = TitleContent {
                                         titleTextString: titleText;
                                         titleLogoColor: Color.GREEN;
                                     }

    var mainContent: MainContentWelcome = MainContentWelcome {
                                              labelText: mainLabelText;
                                          }

    var buttonContent: ButtonContent = ButtonContent {
                                           visibleButtonBack: false
                                           visibleButtonCancel: false
                                           visibleButtonHelp: false
                                           textButtonNext: "Finish"
                                       };

    public override function getNext(): String {
        return "";
    }

    public override function getPrevious(): String {
        return "";
    }

    public override function beforeShow(): Void {

        if (( Main.installData.isCustomInstallation() ) and ( not Main.installData.isMaskedCompleteUninstallation() )) {
            var dialogText: String = ResourceManager.getString("String_UninstallationCompleted2_Partial");
            // panel.setDialogText(dialogText);
        }

        if ( Main.installData.isAbortedInstallation() ) {
            var titleText: String = ResourceManager.getString("String_UninstallationCompleted1_Abort");
            // panel.setTitleText(titleText);
            var dialogText: String = ResourceManager.getString("String_UninstallationCompleted2_Abort");
            // panel.setDialogText(dialogText);
        } else if ( Main.installData.isErrorInstallation() ) {
            var titleText: String = ResourceManager.getString("String_UninstallationCompleted1_Error");
            // panel.setTitleText(titleText);
            var dialogText: String = ResourceManager.getString("String_UninstallationCompleted2_Error");
            // panel.setDialogText(dialogText);
        }

        var productData: ProductDescription = SetupDataProvider.getProductDescription();
        htmlInfoText = InfoCtrl.setHtmlFrame("header", htmlInfoText);
        htmlInfoText = InfoCtrl.setInstallLogInfoText(productData, htmlInfoText);
        htmlInfoText = InfoCtrl.setHtmlFrame("end", htmlInfoText);
    }

    public override function duringShow(): Void {
    }

    public override function afterShow(isNext: Boolean): Boolean {
        var repeatDialog: Boolean = false;
        return repeatDialog
    }

    public override function getName(): String {
        return dialogName;
    }

    public override function getHelpFileName(): String {
        return helpFileName;
    }

    public override function getHelpText(): String {
        return helpFileText;
    }

    public override function getTitleContent(): TitleContent {
        return titleContent
    }

    public override function getMainContent(): MainContent {
        return mainContent
    }

    public override function getButtonContent(): ButtonContent {
        return buttonContent
    }

    public override function getButtonEvent(button: String): String {
        var event : String;
        if ( button.equals("buttonBack")) { event = "back" }
        else if ( button.equals("buttonNext")) { event = "exit" }
        else if ( button.equals("buttonCancel")) { event = "cancel" }
        else if ( button.equals("buttonHelp")) { event = "help" }
        return event
    }


}
