/*
 * ButtonContent.fx
 *
 * Created on 23.07.2009, 18:44:03
 */

package org.openoffice.setup.FX.frame;

import org.openoffice.setup.FX.*;
import javafx.scene.control.Button;
import javafx.scene.effect.DropShadow;
import javafx.scene.layout.HBox;

/**
 * @author is93718
 */

public class ButtonContent {

    public var textButtonBack: String = "< Back";
    public var textButtonNext: String = "Next >";
    public var textButtonCancel: String = "Cancel";
    public var textButtonHelp: String = "Help";
    public var visibleButtonBack: Boolean = true;
    public var visibleButtonNext: Boolean = true;
    public var visibleButtonCancel: Boolean = true;
    public var visibleButtonHelp: Boolean = true;
    public var disableButtonBack: Boolean = false;
    public var disableButtonNext: Boolean = false;
    public var disableButtonCancel: Boolean = false;
    public var disableButtonHelp: Boolean = false;

    public var publicVisibleButtonNext = visibleButtonNext;
    public var publicVisibleButtonCancel = visibleButtonCancel;

    public function updateContent(): Void {
        visibleButtonNext = publicVisibleButtonNext;
        visibleButtonCancel = publicVisibleButtonCancel;
    }

    def buttonBack: Button = Button {
                              text: bind textButtonBack
                              visible: bind visibleButtonBack
                              disable: bind disableButtonBack
                              action: function() {
                                  Main.dialogController.showNewDialog("buttonBack");
                              }
                          }

    def buttonNext: Button = Button {
                              text: bind textButtonNext
                              visible: bind visibleButtonNext
                              disable: bind disableButtonNext
                              action: function() {
                                  Main.dialogController.showNewDialog("buttonNext");
                              }
                          }

    def buttonCancel: Button = Button {
                              text: bind textButtonCancel
                              visible: bind visibleButtonCancel
                              disable: bind disableButtonCancel
                              action: function() {
                                  Main.dialogController.showNewDialog("buttonCancel");
                              }
                          }

    def buttonHelp: Button = Button {
                              text: bind textButtonHelp
                              visible: bind visibleButtonHelp
                              disable: bind disableButtonHelp
                              action: function() {
                                  Main.dialogController.showNewDialog("buttonHelp");
                              }
                          }

    def buttonBox: HBox = HBox {
                           spacing: 10
                           effect: DropShadow { }
                           content: [ buttonBack, buttonNext, buttonCancel, buttonHelp ]
                       };

    public function getButtonTexts(): String {
        return "{buttonBack.text}, {buttonNext.text}, {buttonCancel.text}, {buttonHelp.text}";
    }

    public function getButtonBox(): HBox {
        return buttonBox
    }

}
