/*
 * MainContent.fx
 *
 * Created on 24.07.2009, 17:15:35
 */

package org.openoffice.setup.FX.frame;

import javafx.scene.control.Label;
import javafx.scene.layout.VBox;





import javax.swing.JEditorPane;

import java.io.File;
import java.lang.Exception;
import java.lang.System;
import org.openoffice.setup.FX.Main;
import org.openoffice.setup.ResourceManager;

import javafx.ext.swing.SwingComponent;

import javax.swing.JScrollPane;

import java.awt.Dimension;
import java.awt.Insets;
import javax.swing.ScrollPaneConstants;
import javax.swing.border.EmptyBorder;

/**
 * @author is93718
 */

public class MainContentLicense extends MainContent {

    public var labelText: String = "default text";
    public var licenseText: String = "default License text";

    def label1: Label = Label {
                              text: bind labelText
                          }

    function createEditorPane(): JEditorPane {
        var editorPane: JEditorPane = new JEditorPane();
        editorPane.setEditable(false);
        editorPane.setSize(50, 60);

        var htmlDirectory: File = Main.installData.getInfoRoot("html");
        var licenseFile: String = ResourceManager.getFileName("String_License_Filename");

        if ( htmlDirectory != null) {
            var htmlFile: File = new File(htmlDirectory, licenseFile);
            if (not htmlFile.exists()) {
                System.err.println("Couldn't find file: {htmlFile.toString()}");
            }

            try {
                // System.err.println("URLPath: " + htmlFile.toURL());
                editorPane.setContentType("text/html;charset=utf-8");
                editorPane.setPage(htmlFile.toURL());
            } catch (e: Exception) {
                e.printStackTrace();
                System.err.println("Attempted to read a bad URL");
            }
        } else {
            System.err.println("Did not find html directory");
        }

        return editorPane;

    }

    public var textPane: JEditorPane = createEditorPane();

    public var scrollPane: JScrollPane = new JScrollPane(textPane,
                                      ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
                                      ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED
                                  );

    public var displayText: SwingComponent = SwingComponent.wrap(scrollPane);


/*
    def licenseContent: SwingLabel = SwingLabel {
                                         width: 80
                                         height: 60
                                         text: bind licenseText
                                         // text: "<html><div style=\"padding: 5px; border: white-space:pre-wrap; width:270px; height:60px;\">{licenseText}</div></html>"
    }

    def licensePane: SwingScrollPane = SwingScrollPane {
                                           scrollable: true
                                           height: 50
                                           width: 200
                                           opacity: 1
                                           effect: DropShadow { }
                                           view: licenseContent
    }
*/

    def mainBox: VBox = VBox {
                             spacing: 10
                             width: 200
                             height: 60
                             // effect: DropShadow { }
                             // content: [label1, licensePane]
                             content: [label1, displayText]
                         };

    public override function getMainBox(): VBox {
        return mainBox
    }

}
