/*
 * TitlePanel.fx
 *
 * Created on 23.07.2009, 17:56:04
 */

package org.openoffice.setup.FX.frame;

import org.openoffice.setup.FX.*;
import javafx.scene.paint.Color;
import javafx.scene.paint.RadialGradient;
import javafx.scene.paint.Stop;
import javafx.scene.shape.Circle;
import javafx.scene.text.Font;
import javafx.scene.text.Text;

import javafx.scene.effect.DropShadow;
import javafx.scene.layout.HBox;

/**
 * @author is93718
 */

public class TitleContent {

    public var titleTextString: String;
    public var titleLogoColor: Color;

    def titleText: Text = Text {
                          font : Font {size : 18}
                          x: 10
                          y: 30
                          content: bind titleTextString
                      }

    def titleLogo: Circle = Circle {
                            radius: 10
                            // centerX: 5
                            // centerY: 5
                            // visible: bind showKeyPress
                            // fill: circleFill
                            // fill: Color.ORANGE
                            fill: bind titleLogoColor
                            opacity: bind Main.titleLogoOpacity
                        }

    def circleFill: RadialGradient = RadialGradient {
                                     centerX:0.5
                                     centerY:0.5
                                     radius:0.5
                                     stops: [
                                         Stop {
                                             offset:0
                                             color: Color.WHITESMOKE
                                         },
                                         Stop {
                                             offset:1
                                             color: Color.ORANGE
                                         }
                                     ]
                                 };

    def clockText: Text = Text {
        font: Font { size: 18 }
        x: 40,
        y: 40
        content: bind Main.dTime
    }

    def titleBox: HBox = HBox {
                                    spacing: 20
                                    // effect: DropShadow { }
                                    content: [ titleText, titleLogo, clockText ]
                                };

    public function getTitleTextString(): String {
        return titleTextString;
    }

    public function getTitleLogoColor(): String {
        return titleLogoColor.toString();
    }

    public function getTitleBox(): HBox {
        return titleBox
    }

}
