/*
 * HelpDialog.fx
 *
 * Created on 06.08.2009, 12:53:34
 */

package org.openoffice.setup.FX.helpdialog;

import javafx.scene.Node;
import javafx.scene.control.Control;
import javax.swing.JEditorPane;

import java.io.File;
import java.lang.Exception;
import java.lang.System;
import org.openoffice.setup.FX.Main;
import org.openoffice.setup.ResourceManager;

import javafx.stage.Alert;

/**
 * @author is93718
 */

public class HelpDialog extends Control {

    public var windowWidth: Number = 150;
    public var heading: String;
    public var displayFile: String;
    public var editorPane: JEditorPane;
    public var buttonConfirm: String;
    public var onConfirm: function():Void;
    public var disappearOnAction = true;

    public function makeVisible() {
        visible = true;
        (skin as HelpDialogSkin).makeVisible();
    }

    public function triggerUpdate(helpFileString: String): Void {
        (skin as HelpDialogSkin).updateMainBox = helpFileString;
    }

    public function createEditorPane(helpFileString: String): JEditorPane {
        var editorPane: JEditorPane = new JEditorPane();
        editorPane.setEditable(false);
        var htmlDirectory: File = Main.installData.getInfoRoot("html");

        // Alert.inform("htmldir: {htmlDirectory.getPath()}");

        if ( htmlDirectory != null) {
            var helpFileName: String = ResourceManager.getFileName(helpFileString);
            var htmlFile: File = new File(htmlDirectory, helpFileName);

            // Alert.inform("htmlfile {htmlFile.getPath()}");

            if (( not htmlFile.exists() ) or ( not htmlFile.isFile() )) {
                System.err.println("Couldn't find file: {htmlFile.toString()}");
            }

            try {
                editorPane.setContentType("text/html;charset=utf-8");
                editorPane.setPage(htmlFile.toURL());
            } catch (e: Exception) {
                e.printStackTrace();
                System.err.println("Attempted to read a bad URL");
            }
        } else {
            System.err.println("Did not find html directory");
        }

        return editorPane
    }

    protected override function create(): Node {
        skin = HelpDialogSkin { };
        super.create();
    }
}
